%define __MMX__ 1
%define __SSE__ 2
%define __SSE2__ 3
%define __SSE3__ 4
%define __SSSE3__ 5
%define __SSE4_1__ 6
%define __SSE4_2__ 7
%define __AVX__ 8
%define __AVX2__ 9
%define __FMA3__ 10
%define __AVX512F__ 11
%define __AMX__ 12


%macro impl_body 1
%ifidn __OUTPUT_FORMAT__, elf64
    movd xmm0, edi
    movd xmm1, esi
    mov r8d, esi
%elifidn __OUTPUT_FORMAT__, win64
;    movzx r9d, WORD [rdx]
;    movzx r10d, BYTE [rdx+2]
;    shl r10d, 16
;    or r9d, r10d
    movd xmm0, DWORD [rdx]
    movd xmm1, r8d
%else
%error "Unsupported output format"
%endif

    pmovzxbd xmm0, xmm0 ; 0-extend 8bit->32bit
    pmovzxbd xmm1, xmm1 ; 0-extend 8bit->32bit
    shr r8d, 24
%if %1 >= __AVX512F__
    vpbroadcastd xmm2, r8d ; fill vector with 32bit values
%elif %1 >= __AVX2__
    movd xmm2, r8d
    vpbroadcastd xmm2, xmm2
%endif
    mov r8d, 255
%if %1 >= __AVX512F__
    vpbroadcastd xmm3, r8d ; fill vector with 32bit values
%elif %1 >= __AVX2__
    movd xmm3, r8d
    vpbroadcastd xmm3, xmm3
%endif

    psubd xmm3, xmm2  ; sub 32bit integers
    pmuludq xmm0, xmm3  ; mul unsigned 32bit integers
    pmuludq xmm1, xmm2 ; mul unsigned 32bit integers
    paddd xmm0, xmm1 ; add 32bit integers
    psrld xmm0, 8 ; 0-shift 32bit integers right

    pextrd r9d, xmm0, 0  ; extracts 32 bit integer
    pextrd r10d, xmm0, 1  ; extracts 32 bit integer
    pextrd r11d, xmm0, 2 ; extracts 32 bit integer
    shl r10d, 8
    shl r11d, 16
    or r9d, r10d
    or r9d, r11d

%ifidn __OUTPUT_FORMAT__, elf64
    mov eax, r9d
%elifidn __OUTPUT_FORMAT__, win64
    mov DWORD [rcx], r9d
%else
%error "Unsupported output format"
%endif
    ret
%endmacro


section .text


; avx2

global ?_apply_transparent_color_avx2@Utilities@ComputerGraphicsLabWork@BGTU@@YA?AVColor@RendererApi@23@V4523@VTransparent@4523@@Z ; msvc

?_apply_transparent_color_avx2@Utilities@ComputerGraphicsLabWork@BGTU@@YA?AVColor@RendererApi@23@V4523@VTransparent@4523@@Z:
impl_body __AVX2__